// This source code is licensed under the 3-clause BSD license found
// in the LICENSE file in the root directory of this project.

#pragma once

#include "shared_array.h"

#include <complex>

namespace spex {

auto fft_r2c(const int n_rows,
             const int n_cols,
             std::vector<double>& image,
             SharedArray<std::complex<double>>& image_fft) -> void;

auto convolve(const int image_n_rows,
              const int image_n_cols,
              const std::vector<double>& image_in,
              const int kernel_n_rows,
              const int kernel_n_cols,
              const spex::SharedArray<double>& kernel_in,
              const spex::SharedArray<std::complex<double>>& kernel_fft,
              std::vector<double>& image_out) -> void;

} // namespace spex
