// This source code is licensed under the 3-clause BSD license found
// in the LICENSE file in the root directory of this project.

#pragma once

#include "processor.h"

namespace spex {

class L1C : public Processor
{
public:
    L1C(const gadfit::MPIVars& mpi, const SPEXSettings& settings, CKD& ckd)
      : Processor { mpi, settings, ProcLevel::l1c, ckd }
    {}

protected:
    auto processInit() -> void override;
    // There are no batches
    auto prepareBatches() -> void override {}
};

} // namespace spex
